IOSS 2.0

Public Member Functions | Static Public Member Functions | Private Member Functions | Static Private Member Functions | Private Attributes | Static Private Attributes | List of all members
Iovs::DatabaseIO Class Reference

`#include <Iovs_DatabaseIO.h>`

Inheritance diagram for Iovs::DatabaseIO:
[legend]
Collaboration diagram for Iovs::DatabaseIO:
[legend]

## Public Member Functions
| DatabaseIO (Ioss::Region *region, const std::string &filename, Ioss::DatabaseUsage db_usage, MPI_Comm communicator, const Ioss::PropertyManager &props)
| ~DatabaseIO () override
const std::string | get_format () const override
unsigned | entity_field_support () const override
int | int_byte_size_db () const override
Public Member Functions inherited from Ioss::DatabaseIO
bool | ok (bool write_message=false, std::string *error_message=nullptr, int *bad_count=nullptr) const
| Check to see if database state is OK. More...
bool | using_parallel_io () const
int64_t | node_global_to_local (int64_t global, bool must_exist) const
| Get the local (process-specific) node number corresponding to a global node number. More...
int64_t | element_global_to_local (int64_t global) const
virtual bool | node_major () const
void | release_memory ()
virtual void | finalize_database ()
void | set_pfsname (const std::string &name) const
std::string | get_pfsname () const
void | set_dwname (const std::string &name) const
| this will be the name in BB namespace More...
std::string | get_dwname () const
std::string | get_dwPath () const
| We call this ONLY after we assure that using_dw() is TRUE \ returns mount point of Datawarp namespace, e.g: `/opt/cray/....<jobid>` More...
void | check_setDW () const
bool | using_dw () const
std::string | get_filename () const
| Get the file name associated with the database. More...
virtual int | get_file_pointer () const
const std::string & | decoded_filename () const
| Get a file-per-processor filename associated with the database. More...
bool | is_input () const
| Determine whether the database is an input database. More...
Ioss::DatabaseUsage | usage () const
| Get the Ioss::DatabaseUsage type of the database. More...
virtual bool | needs_shared_node_information () const
| Determine whether the database needs information about process ownership of nodes. More...
Ioss::IfDatabaseExistsBehavior | open_create_behavior () const
void | create_path (const std::string &filename) const
| This function is used to create the path to an output directory (or history, restart, etc.) More...
void | set_region (Region *region)
void | openDW (const std::string &filename) const
| If we are planning to use BB(aka Burst Buffer) service, we will call simple C API provided by Cray DataWarp module. More...
void | closeDW () const
| Function which invokes stageout from BB to Disk, prior to completion of final close. More...
void | openDatabase () const
void | closeDatabase () const
void | flush_database () const
bool | open_group (const std::string &group_name)
| If a database type supports groups and if the database contains groups, open the specified group. More...
bool | create_subgroup (const std::string &group_name)
| If a database type supports groups, create the specified group as a child of the current group. More...
bool | begin (Ioss::State state)
| Set the database to the given State. More...
bool | end (Ioss::State state)
| Return the database to STATE_CLOSED. More...
bool | begin_state (int state, double time)
bool | end_state (int state, double time)
void | read_meta_data ()
void | get_step_times ()
virtual bool | internal_edges_available () const
virtual bool | internal_faces_available () const
const std::vector< std::string > & | get_information_records () const
| Get all information records (informative strings) for the database. More...
void | add_information_records (const std::vector< std::string > &info)
| Add multiple information records (informative strings) to the database. More...
void | add_information_record (const std::string &info)
| Add an information record (an informative string) to the database. More...
const std::vector< std::string > & | get_qa_records () const
| Get all QA records, each of which consists of 4 strings, from the database. More...
void | add_qa_record (const std::string &code, const std::string &code_qa, const std::string &date, const std::string &time)
| Add a QA record, which consists of 4 strings, to the database. More...
bool | get_logging () const
void | set_logging (bool on_off)
template<typename T >
int64_t | get_field (const T *reg, const Field &field, void *data, size_t data_size) const
template<typename T >
int64_t | put_field (const T *reg, const Field &field, void *data, size_t data_size) const
bool | is_parallel_consistent () const
void | set_parallel_consistency (bool on_off)
bool | get_use_generic_canonical_name () const
void | set_use_generic_canonical_name (bool yes_no)
bool | ignore_database_names () const
void | ignore_database_names (bool yes_no)
virtual int | maximum_symbol_length () const
| Get the length of the longest name in the database file. More...
virtual void | set_maximum_symbol_length (int)
char | get_field_separator () const
bool | get_field_recognition () const
void | set_field_separator (char separator)
| Set the character used to separate a field suffix from the field basename when recognizing vector, tensor fields. More...
void | set_field_recognition (bool yes_no)
void | set_lower_case_variable_names (bool true_false) const
void | set_surface_split_type (Ioss::SurfaceSplitType split_type)
Ioss::SurfaceSplitType | get_surface_split_type () const
void | set_block_omissions (const std::vector< std::string > &omissions, const std::vector< std::string > &inclusions={})
void | get_block_adjacencies (const Ioss::ElementBlock *eb, std::vector< std::string > &block_adjacency) const
void | compute_block_membership (Ioss::SideBlock *efblock, std::vector< std::string > &block_membership) const
AxisAlignedBoundingBox | get_bounding_box (const Ioss::ElementBlock *eb) const
AxisAlignedBoundingBox | get_bounding_box (const Ioss::StructuredBlock *sb) const
int | int_byte_size_api () const
| Returns 4 or 8. More...
virtual void | set_int_byte_size_api (Ioss::DataSize size) const
| Returns 4 or 8. More...
Region * | get_region () const
void | set_cycle_count (int count) const
int | get_cycle_count () const
void | set_overlay_count (int count) const
int | get_overlay_count () const
void | set_file_per_state (bool yes_no) const
bool | get_file_per_state () const
void | set_time_scale_factor (double factor)
const Ioss::ParallelUtils & | util () const
const Ioss::PropertyManager & | get_property_manager () const
int | parallel_rank () const
| Get the processor that this mesh database is on. More...
int | parallel_size () const
bool | is_parallel () const
void | progress (const std::string &output) const

## Static Public Member Functions
static int | parseCatalystFile (const std::string &filepath, std::string &json_result)

## Private Member Functions
bool | begin__ (Ioss::State state) override
bool | end__ (Ioss::State state) override
bool | begin_state__ (int state, double time) override
bool | end_state__ (int state, double time) override
void | read_meta_data__ () override
int64_t | get_field_internal (const Ioss::Region *, const Ioss::Field &, void *, size_t) const override
int64_t | get_field_internal (const Ioss::NodeBlock *, const Ioss::Field &, void *, size_t) const override
int64_t | get_field_internal (const Ioss::EdgeBlock *, const Ioss::Field &, void *, size_t) const override
int64_t | get_field_internal (const Ioss::FaceBlock *, const Ioss::Field &, void *, size_t) const override
int64_t | get_field_internal (const Ioss::ElementBlock *, const Ioss::Field &, void *, size_t) const override
int64_t | get_field_internal (const Ioss::SideBlock *, const Ioss::Field &, void *, size_t) const override
int64_t | get_field_internal (const Ioss::NodeSet *, const Ioss::Field &, void *, size_t) const override
int64_t | get_field_internal (const Ioss::EdgeSet *, const Ioss::Field &, void *, size_t) const override
int64_t | get_field_internal (const Ioss::FaceSet *, const Ioss::Field &, void *, size_t) const override
int64_t | get_field_internal (const Ioss::ElementSet *, const Ioss::Field &, void *, size_t) const override
int64_t | get_field_internal (const Ioss::SideSet *, const Ioss::Field &, void *, size_t) const override
int64_t | get_field_internal (const Ioss::CommSet *, const Ioss::Field &, void *, size_t) const override
int64_t | get_field_internal (const Ioss::StructuredBlock *, const Ioss::Field &, void *, size_t) const override
int64_t | put_field_internal (const Ioss::Region *reg, const Ioss::Field &field, void *data, size_t data_size) const override
int64_t | put_field_internal (const Ioss::NodeBlock *nb, const Ioss::Field &field, void *data, size_t data_size) const override
int64_t | put_field_internal (const Ioss::EdgeBlock *, const Ioss::Field &, void *, size_t) const override
int64_t | put_field_internal (const Ioss::FaceBlock *, const Ioss::Field &, void *, size_t) const override
int64_t | put_field_internal (const Ioss::ElementBlock *eb, const Ioss::Field &field, void *data, size_t data_size) const override
int64_t | put_field_internal (const Ioss::SideBlock *eb, const Ioss::Field &field, void *data, size_t data_size) const override
int64_t | put_field_internal (const Ioss::NodeSet *ns, const Ioss::Field &field, void *data, size_t data_size) const override
int64_t | put_field_internal (const Ioss::EdgeSet *, const Ioss::Field &, void *, size_t) const override
int64_t | put_field_internal (const Ioss::FaceSet *, const Ioss::Field &, void *, size_t) const override
int64_t | put_field_internal (const Ioss::ElementSet *, const Ioss::Field &, void *, size_t) const override
int64_t | put_field_internal (const Ioss::SideSet *fs, const Ioss::Field &field, void *data, size_t data_size) const override
int64_t | put_field_internal (const Ioss::CommSet *, const Ioss::Field &, void *, size_t) const override
int64_t | put_field_internal (const Ioss::StructuredBlock *, const Ioss::Field &, void *, size_t) const override
void | write_meta_data ()
int64_t | handle_node_ids (void *ids, int64_t num_to_get)
int64_t | handle_element_ids (const Ioss::ElementBlock *eb, void *ids, size_t num_to_get)
const Ioss::Map & | get_node_map () const
const Ioss::Map & | get_element_map () const
| DatabaseIO ()
| DatabaseIO (const DatabaseIO &)
DatabaseIO & | operator= (const DatabaseIO &)
void | create_global_node_and_element_ids () const

## Static Private Member Functions
static ParaViewCatalystIossAdapterBase * | load_plugin_library (const std::string &plugin_name, const std::string &plugin_library_name)
static std::string | create_output_file_path (const std::string &input_deck_name, const Ioss::PropertyManager &properties)

## Private Attributes
bool | isInput
bool | singleProcOnly
bool | doLogging
std::string | databaseTitle
std::string | catalyst_block_file_name
std::string | paraview_json_parse
std::string | sierra_input_deck_name
std::string | catalyst_output_directory
std::string | paraview_script_extra_filename
int | enableLogging
int | debugLevel
int | underscoreVectors
int | applyDisplacements
int | createSideSets
int | createNodeSets
int | nodeBlockCount
int | elementBlockCount
ParaViewCatalystIossAdapterBase * | pvcsa
bool | globalNodeAndElementIDsCreated
EntityIdSet | ids_

## Static Private Attributes
static std::string | paraview_script_filename
static int | useCount = 0
static int | uniqueID

## Additional Inherited Members
Protected Member Functions inherited from Ioss::DatabaseIO
| DatabaseIO (Region *region, std::string filename, Ioss::DatabaseUsage db_usage, MPI_Comm communicator, const Ioss::PropertyManager &props)
void | set_common_side_topology () const
template<typename T >
void | create_groups (const std::string &property_name, EntityType type, const std::string &type_name, const T *set_type)
template<typename T >
void | create_group (EntityType type, const std::string &type_name, const std::vector< std::string > &group_spec, const T *set_type)
void | handle_groups ()
void | check_side_topology () const
virtual void | openDatabase__ () const
virtual void | closeDatabase__ () const
virtual void | flush_database__ () const
template<>
void | create_group (EntityType type, const std::string &, const std::vector< std::string > &group_spec, const SideSet *)
Protected Attributes inherited from Ioss::DatabaseIO
Ioss::PropertyManager | properties
ElementTopology * | commonSideTopology {nullptr}
std::string | originalDBFilename
std::string | DBFilename
std::string | decodedFilename
std::string | bbName {}
std::string | pfsName {}
std::string | dwPath {}
Ioss::State | dbState {STATE_INVALID}
int | myProcessor {0}
| number of processor this database is for More...
int64_t | nodeCount {0}
int64_t | elementCount {0}
TopoContainer | sideTopology
| Used to speed up faceblock/edgeblock calculations. More...
int | cycleCount {0}
int | overlayCount {0}
double | timeScaleFactor {1.0}
Ioss::SurfaceSplitType | splitType {SPLIT_BY_TOPOLOGIES}
Ioss::DatabaseUsage | dbUsage
Ioss::DataSize | dbIntSizeAPI {USE_INT32_API}
bool | filePerState {false}
bool | usingDataWarp {false}
bool | isParallel {false}
| true if running in parallel More...
bool | lowerCaseVariableNames {true}
bool | usingParallelIO {false}
std::vector< std::string > | blockOmissions
std::vector< std::string > | blockInclusions
std::vector< std::string > | informationRecords
std::vector< std::string > | qaRecords
Ioss::Map | nodeMap {"node", DBFilename, myProcessor}
Ioss::Map | edgeMap {"edge", DBFilename, myProcessor}
Ioss::Map | faceMap {"face", DBFilename, myProcessor}
Ioss::Map | elemMap {"element", DBFilename, myProcessor}
std::vector< std::vector< bool > > | blockAdjacency

## Constructor & Destructor Documentation

## ◆ DatabaseIO() [1/3]

Iovs::DatabaseIO::DatabaseIO | ( | Ioss::Region * | region,
|  | const std::string & | filename,
|  | Ioss::DatabaseUsage | db_usage,
|  | MPI_Comm | communicator,
|  | const Ioss::PropertyManager & | props
| ) |  |

## ◆ ~DatabaseIO()

Iovs::DatabaseIO::~DatabaseIO | ( |  | ) |
| overridevirtual

Reimplemented from Ioss::DatabaseIO.

## ◆ DatabaseIO() [2/3]

Iovs::DatabaseIO::DatabaseIO | ( |  | ) |
| private

## ◆ DatabaseIO() [3/3]

Iovs::DatabaseIO::DatabaseIO | ( | const DatabaseIO & |  | ) |
| private

## Member Function Documentation

## ◆ begin__()

bool Iovs::DatabaseIO::begin__ | ( | Ioss::State | state | ) |
| overrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ begin_state__()

bool Iovs::DatabaseIO::begin_state__ | ( | int | state,
|  | double | time
| ) |  |
| overrideprivatevirtual

Reimplemented from Ioss::DatabaseIO.

## ◆ create_global_node_and_element_ids()

void Iovs::DatabaseIO::create_global_node_and_element_ids | ( |  | ) | const
| private

## ◆ create_output_file_path()

std::string Iovs::DatabaseIO::create_output_file_path | ( | const std::string & | input_deck_name,
|  | const Ioss::PropertyManager & | properties
| ) |  |
| staticprivate

## ◆ end__()

bool Iovs::DatabaseIO::end__ | ( | Ioss::State | state | ) |
| overrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ end_state__()

bool Iovs::DatabaseIO::end_state__ | ( | int | state,
|  | double | time
| ) |  |
| overrideprivatevirtual

Reimplemented from Ioss::DatabaseIO.

## ◆ entity_field_support()

unsigned Iovs::DatabaseIO::entity_field_support | ( |  | ) | const
| inlineoverridevirtual

Implements Ioss::DatabaseIO.

## ◆ get_element_map()

const Ioss::Map & Iovs::DatabaseIO::get_element_map | ( |  | ) | const
| private

## ◆ get_field_internal() [1/13]

int64_t Iovs::DatabaseIO::get_field_internal | ( | const Ioss::CommSet * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ get_field_internal() [2/13]

int64_t Iovs::DatabaseIO::get_field_internal | ( | const Ioss::EdgeBlock * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ get_field_internal() [3/13]

int64_t Iovs::DatabaseIO::get_field_internal | ( | const Ioss::EdgeSet * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ get_field_internal() [4/13]

int64_t Iovs::DatabaseIO::get_field_internal | ( | const Ioss::ElementBlock * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ get_field_internal() [5/13]

int64_t Iovs::DatabaseIO::get_field_internal | ( | const Ioss::ElementSet * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ get_field_internal() [6/13]

int64_t Iovs::DatabaseIO::get_field_internal | ( | const Ioss::FaceBlock * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ get_field_internal() [7/13]

int64_t Iovs::DatabaseIO::get_field_internal | ( | const Ioss::FaceSet * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ get_field_internal() [8/13]

int64_t Iovs::DatabaseIO::get_field_internal | ( | const Ioss::NodeBlock * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ get_field_internal() [9/13]

int64_t Iovs::DatabaseIO::get_field_internal | ( | const Ioss::NodeSet * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ get_field_internal() [10/13]

int64_t Iovs::DatabaseIO::get_field_internal | ( | const Ioss::Region * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ get_field_internal() [11/13]

int64_t Iovs::DatabaseIO::get_field_internal | ( | const Ioss::SideBlock * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ get_field_internal() [12/13]

int64_t Iovs::DatabaseIO::get_field_internal | ( | const Ioss::SideSet * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ get_field_internal() [13/13]

int64_t Iovs::DatabaseIO::get_field_internal | ( | const Ioss::StructuredBlock * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Reimplemented from Ioss::DatabaseIO.

## ◆ get_format()

const std::string Iovs::DatabaseIO::get_format | ( |  | ) | const
| inlineoverridevirtual

Return a string specifying underlying format of database (exodus, cgns, ...)

Implements Ioss::DatabaseIO.

## ◆ get_node_map()

const Ioss::Map & Iovs::DatabaseIO::get_node_map | ( |  | ) | const
| private

## ◆ handle_element_ids()

int64_t Iovs::DatabaseIO::handle_element_ids | ( | const Ioss::ElementBlock * | eb,
|  | void * | ids,
|  | size_t | num_to_get
| ) |  |
| private

## ◆ handle_node_ids()

int64_t Iovs::DatabaseIO::handle_node_ids | ( | void * | ids,
|  | int64_t | num_to_get
| ) |  |
| private

There are two modes we need to support in this routine:

1. Initial definition of node map (local->global) and reverseNodeMap (global->local).
2. Redefinition of node map via 'reordering' of the original map when the nodes on this processor are the same, but their order is changed (or count because of ghosting)

So, there will be two maps the 'nodeMap' map is a 'direct lookup' map which maps current local position to global id and the 'reverseNodeMap' is an associative lookup which maps the global id to 'original local'. There is also a 'reorderNodeMap' which is direct lookup and maps current local position to original local.

The ids coming in are the global ids; their position is the "local id-1" (That is, data[0] contains the global id of local node 1 in this node block).

int local_position = reverseNodeMap[NodeMap[i+1]] (the nodeMap and reverseNodeMap are 1-based)

To determine which map to update on a call to this function, we use the following hueristics: – If the database state is 'STATE_MODEL:', then update the 'reverseNodeMap' and 'nodeMap'

– If the database state is not STATE_MODEL, then leave the 'reverseNodeMap' and 'nodeMap' alone since they correspond to the information already written to the database. [May want to add a STATE_REDEFINE_MODEL]

– In both cases, update the reorderNodeMap

NOTE: The mapping is done on TRANSIENT fields only; MODEL fields should be in the original order...

## ◆ int_byte_size_db()

int Iovs::DatabaseIO::int_byte_size_db | ( |  | ) | const
| inlineoverridevirtual

Implements Ioss::DatabaseIO.

## ◆ load_plugin_library()

ParaViewCatalystIossAdapterBase * Iovs::DatabaseIO::load_plugin_library | ( | const std::string & | plugin_name,
|  | const std::string & | plugin_library_name
| ) |  |
| staticprivate

## ◆ operator=()

DatabaseIO& Iovs::DatabaseIO::operator= | ( | const DatabaseIO & |  | ) |
| private

## ◆ parseCatalystFile()

int Iovs::DatabaseIO::parseCatalystFile | ( | const std::string & | filepath,
|  | std::string & | json_result
| ) |  |
| static

## ◆ put_field_internal() [1/13]

int64_t Iovs::DatabaseIO::put_field_internal | ( | const Ioss::CommSet * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ put_field_internal() [2/13]

int64_t Iovs::DatabaseIO::put_field_internal | ( | const Ioss::EdgeBlock * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ put_field_internal() [3/13]

int64_t Iovs::DatabaseIO::put_field_internal | ( | const Ioss::EdgeSet * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ put_field_internal() [4/13]

int64_t Iovs::DatabaseIO::put_field_internal | ( | const Ioss::ElementBlock * | eb,
|  | const Ioss::Field & | field,
|  | void * | data,
|  | size_t | data_size
| ) |  | const
| overrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ put_field_internal() [5/13]

int64_t Iovs::DatabaseIO::put_field_internal | ( | const Ioss::ElementSet * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ put_field_internal() [6/13]

int64_t Iovs::DatabaseIO::put_field_internal | ( | const Ioss::FaceBlock * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ put_field_internal() [7/13]

int64_t Iovs::DatabaseIO::put_field_internal | ( | const Ioss::FaceSet * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ put_field_internal() [8/13]

int64_t Iovs::DatabaseIO::put_field_internal | ( | const Ioss::NodeBlock * | nb,
|  | const Ioss::Field & | field,
|  | void * | data,
|  | size_t | data_size
| ) |  | const
| overrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ put_field_internal() [9/13]

int64_t Iovs::DatabaseIO::put_field_internal | ( | const Ioss::NodeSet * | ns,
|  | const Ioss::Field & | field,
|  | void * | data,
|  | size_t | data_size
| ) |  | const
| overrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ put_field_internal() [10/13]

int64_t Iovs::DatabaseIO::put_field_internal | ( | const Ioss::Region * | reg,
|  | const Ioss::Field & | field,
|  | void * | data,
|  | size_t | data_size
| ) |  | const
| overrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ put_field_internal() [11/13]

int64_t Iovs::DatabaseIO::put_field_internal | ( | const Ioss::SideBlock * | eb,
|  | const Ioss::Field & | field,
|  | void * | data,
|  | size_t | data_size
| ) |  | const
| overrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ put_field_internal() [12/13]

int64_t Iovs::DatabaseIO::put_field_internal | ( | const Ioss::SideSet * | fs,
|  | const Ioss::Field & | field,
|  | void * | data,
|  | size_t | data_size
| ) |  | const
| overrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ put_field_internal() [13/13]

int64_t Iovs::DatabaseIO::put_field_internal | ( | const Ioss::StructuredBlock * | ,
|  | const Ioss::Field & | ,
|  | void * | ,
|  | size_t |
| ) |  | const
| inlineoverrideprivatevirtual

Reimplemented from Ioss::DatabaseIO.

## ◆ read_meta_data__()

void Iovs::DatabaseIO::read_meta_data__ | ( |  | ) |
| overrideprivatevirtual

Implements Ioss::DatabaseIO.

## ◆ write_meta_data()

void Iovs::DatabaseIO::write_meta_data | ( |  | ) |
| private

## Member Data Documentation

## ◆ applyDisplacements

int Iovs::DatabaseIO::applyDisplacements
| private

## ◆ catalyst_block_file_name

std::string Iovs::DatabaseIO::catalyst_block_file_name
| private

## ◆ catalyst_output_directory

std::string Iovs::DatabaseIO::catalyst_output_directory
| private

## ◆ createNodeSets

int Iovs::DatabaseIO::createNodeSets
| private

## ◆ createSideSets

int Iovs::DatabaseIO::createSideSets
| private

## ◆ databaseTitle

std::string Iovs::DatabaseIO::databaseTitle
| private

## ◆ debugLevel

int Iovs::DatabaseIO::debugLevel
| private

## ◆ doLogging

bool Iovs::DatabaseIO::doLogging
| private

## ◆ elementBlockCount

int Iovs::DatabaseIO::elementBlockCount
| private

## ◆ enableLogging

int Iovs::DatabaseIO::enableLogging
| private

## ◆ globalNodeAndElementIDsCreated

bool Iovs::DatabaseIO::globalNodeAndElementIDsCreated
| mutableprivate

## ◆ ids_

EntityIdSet Iovs::DatabaseIO::ids_
| mutableprivate

## ◆ isInput

bool Iovs::DatabaseIO::isInput
| private

## ◆ nodeBlockCount

int Iovs::DatabaseIO::nodeBlockCount
| private

## ◆ paraview_json_parse

std::string Iovs::DatabaseIO::paraview_json_parse
| private

## ◆ paraview_script_extra_filename

std::string Iovs::DatabaseIO::paraview_script_extra_filename
| private

## ◆ paraview_script_filename

std::string Iovs::DatabaseIO::paraview_script_filename
| staticprivate

## ◆ pvcsa

ParaViewCatalystIossAdapterBase* Iovs::DatabaseIO::pvcsa
| private

## ◆ sierra_input_deck_name

std::string Iovs::DatabaseIO::sierra_input_deck_name
| private

## ◆ singleProcOnly

bool Iovs::DatabaseIO::singleProcOnly
| private

## ◆ underscoreVectors

int Iovs::DatabaseIO::underscoreVectors
| private

## ◆ uniqueID

int Iovs::DatabaseIO::uniqueID
| staticprivate

## ◆ useCount

int Iovs::DatabaseIO::useCount = 0
| staticprivate

The documentation for this class was generated from the following files:

- src/visualization/Iovs_DatabaseIO.h
- src/visualization/Iovs_DatabaseIO.C